package com.zcloud.personnel.positioning.web;

import com.zcloud.personnel.positioning.api.AlarmRuleItemServiceI;
import com.zcloud.personnel.positioning.dto.AlarmRuleItemAddCmd;
import com.zcloud.personnel.positioning.dto.AlarmRuleItemPageQry;
import com.zcloud.personnel.positioning.dto.AlarmRuleItemUpdateCmd;
import com.zcloud.personnel.positioning.dto.clientobject.AlarmRuleItemCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * web-adapter
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Api(tags = "告警规则项")
@RequestMapping("/${application.gateway}/alarmRuleItem")
@RestController
@AllArgsConstructor
public class AlarmRuleItemController {
    private final AlarmRuleItemServiceI alarmRuleItemService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<AlarmRuleItemCO> add(@Validated @RequestBody AlarmRuleItemAddCmd cmd) {
        fillCorpinfo(cmd);
        return alarmRuleItemService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<AlarmRuleItemCO> page(@RequestBody AlarmRuleItemPageQry qry) {
        return alarmRuleItemService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<AlarmRuleItemCO> listAll() {
        return MultiResponse.of(alarmRuleItemService.listAll());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<AlarmRuleItemCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(alarmRuleItemService.queryById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        alarmRuleItemService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        alarmRuleItemService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody AlarmRuleItemUpdateCmd cmd) {
        fillCorpinfo(cmd);
        alarmRuleItemService.edit(cmd);
        return SingleResponse.buildSuccess();
    }

    private void fillCorpinfo(AlarmRuleItemAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }

    private void fillCorpinfo(AlarmRuleItemUpdateCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }
}
